#include "descriptor/descriptor.h"

int main(void)
{

  ITEM	glass, ivory, red, yellow, blue, black, gold, silver, white, brown, light_brown, metal;
  ITEM	guitar1, guitar2, guitar3, guitar_bp, guitar_gp, guitar_rp, guitar_wp, strings, ground;
  ITEM  stand1, stand2, stand3, stand_bp, stand_gp;
  ITEM  back_wall, l_side_wall, r_side_wall;
  ITEM	set1, set2, set3, scene;

  //////////////////////////////////////////////////////////////////
  /// ambiente e luci
  /////////////////////////////////////////////////////////////////

  set_background(0.0, 0.0, 0.0, TRUE);
  set_ambient_light(1, 1, 1, 1.0);

  create_warn_light(13.5, 13.5, 10.0,
  	-0.7, -0.6, -0.35,
	1, 1, 1,
	2.5, 30, 0, 45.0,
	FALSE, 0.0, 0.0, 0.0, 0.0,
	"light1");

  create_warn_light(-13.5, 13.5, 10.0,
  	0.7, -0.6, -0.35,
	1, 1, 1,
	2.5, 30, 0, 45.0,
	FALSE, 0.0, 0.0, 0.0, 0.0,
	"light2");

  create_warn_light(-0.5, 20.0, 10.0,
  	0.004, -0.945, -0.325,
	1, 1, 1,
	4, 30, 0, 45.0,
	FALSE, 0.0, 0.0, 0.0, 0.0,
	"light3");


  //////////////////////////////////////////////////////////////////
  /// attributi
  /////////////////////////////////////////////////////////////////

  glass = create_attribute("glass");
  set_color(glass, 0.68, 0.86, 1, 0.5, 0.5);
  set_reflectivity(glass, 0.24, 2);
  set_transparency(glass, 0.87, 0.68, 1, 1.2);

  ivory = create_attribute("ivory");
  set_color(ivory, 0.98, 0.98, 0.98, 0.3, 0.2);
  set_reflectivity(ivory, 0.1, 15);

  red = create_attribute("red");
  set_color(red, 0.784, 0.196, 0.0, 0.3, 0.2);
  set_reflectivity(red, 0.1, 15);

  brown = create_attribute("brown");
  set_color(brown, 0.588, 0.235, 0.0, 0.3, 0.3);
  set_reflectivity(brown, 0.1, 2);
  set_transparency(glass, 0.0, 0.0, 1, 1.2);

  light_brown = create_attribute("light_brown");
  set_color(light_brown, 0.565, 0.427, 0.263, 0.44, 0.44);

  blue = create_attribute("blue");
  set_color(blue, 0, 0, 1, 0.3, 0.2);
  set_reflectivity(blue, 0.1, 15);

  black = create_attribute("black");
  set_color(black, 0.0, 0.0, 0.0, 0.1, 0.34);
  set_reflectivity(black, 0.2, 128);

  gold = create_attribute("gold");
  set_color(gold, 0.894, 0.71, 0.0, 0.33, 0.33);
  set_reflectivity(gold, 0.46, 128);

  metal = create_attribute("metal");
  set_color(metal, 0.5, 0.5, 0.5, 0.2, 0.2);
  set_reflectivity(metal, 0.25, 128);

  silver = create_attribute("silver");
  set_color(silver, 0.589, 0.589, 0.589, 0.2, 0.2);
  set_reflectivity(silver, 0.45, 128);

  white = create_attribute("white");
  set_color(white, 1.0, 1.0, 1.0, 0.3, 0.3);


  //////////////////////////////////////////////////////////////////
  /// oggetti della scena
  /////////////////////////////////////////////////////////////////
  stand_gp = read_obj("stand-gray-part.obj", "stand-gp");
  set_attribute(stand_gp, metal);

  stand_bp = read_obj("stand-black-part.obj", "stand-bp");
  set_attribute(stand_bp, black);

  stand1 = create_list(stand_gp, "stand");
  stand1 = insert_in_list(stand1, stand_bp);
  set_scale(stand1, 2.0, 2.0, 2.0);
  set_translate(stand1, 0.0, 0.0, 0.1);

  stand2 = create_copy(stand1, "stand");
  stand3 = create_copy(stand1, "stand");


  guitar_rp = read_obj("guitar-red-part.obj",  "guitar-rp");
  set_attribute(guitar_rp, red);

  guitar_wp = read_obj("guitar-white-part.obj",  "guitar-wp");
  set_attribute(guitar_wp, ivory);

  guitar_bp = read_obj("guitar-black-part.obj",  "guitar-bp");
  set_attribute(guitar_bp, black);

  guitar_gp = read_obj("guitar-gold-part.obj",  "guitar-gp");
  set_attribute(guitar_gp, gold);

  strings = read_obj("guitar-strings.obj",  "guitar-strings");
  set_attribute(strings, silver);

  guitar1 = create_list(guitar_bp, "guitar1");
  guitar1 = insert_in_list(guitar1, guitar_rp);
  guitar1 = insert_in_list(guitar1, guitar_gp);
  guitar1 = insert_in_list(guitar1, guitar_wp);
  guitar1 = insert_in_list(guitar1, strings);

  set_scale(guitar1, 2.5, 2.5, 2.5);
  set_translate(guitar1, -0.7, 0.55, 2.3);
  set_x_rotate(guitar1, 10.0, 1);

  guitar_rp = read_obj("guitar-red-part.obj",  "guitar-rp");
  set_attribute(guitar_rp, ivory);

  guitar_wp = read_obj("guitar-white-part.obj",  "guitar-wp");
  set_attribute(guitar_wp, ivory);

  guitar_bp = read_obj("guitar-black-part.obj",  "guitar-bp");
  set_attribute(guitar_bp, black);

  guitar_gp = read_obj("guitar-gold-part.obj",  "guitar-gp");
  set_attribute(guitar_gp, silver);

  strings = read_obj("guitar-strings.obj",  "guitar-strings");
  set_attribute(strings, silver);

  guitar2 = create_list(guitar_bp, "guitar1");
  guitar2 = insert_in_list(guitar2, guitar_rp);
  guitar2 = insert_in_list(guitar2, guitar_gp);
  guitar2 = insert_in_list(guitar2, guitar_wp);
  guitar2 = insert_in_list(guitar2, strings);

  set_scale(guitar2, 2.5, 2.5, 2.5);
  set_translate(guitar2, -0.7, 0.55, 2.3);
  set_x_rotate(guitar2, 10.0, 1);

  guitar_rp = read_obj("guitar-red-part.obj",  "guitar-rp");
  set_attribute(guitar_rp, blue);

  guitar_wp = read_obj("guitar-white-part.obj",  "guitar-wp");
  set_attribute(guitar_wp, red);

  guitar_bp = read_obj("guitar-black-part.obj",  "guitar-bp");
  set_attribute(guitar_bp, light_brown);

  guitar_gp = read_obj("guitar-gold-part.obj",  "guitar-gp");
  set_attribute(guitar_gp, silver);

  strings = read_obj("guitar-strings.obj",  "guitar-strings");
  set_attribute(strings, silver);

  guitar3 = create_list(guitar_bp, "guitar1");
  guitar3 = insert_in_list(guitar3, guitar_rp);
  guitar3 = insert_in_list(guitar3, guitar_gp);
  guitar3 = insert_in_list(guitar3, guitar_wp);
  guitar3 = insert_in_list(guitar3, strings);

  set_scale(guitar3, 2.5, 2.5, 2.5);
  set_translate(guitar3, -0.7, 0.55, 2.3);
  set_x_rotate(guitar3, 10.0, 1);

  ground = read_nurbs("plane.db");
  set_attribute(ground, brown);
  set_scale(ground, 2.0, 2.0, 2.0);
  set_translate(ground, 0.0, 4.0, 0.0);

  back_wall = read_nurbs("plane.db");
  set_attribute(back_wall, white);
  set_scale(back_wall, 2.0, 1.5, 2.0);
  set_translate(back_wall, 0, 14, 12);
  set_x_rotate(back_wall, 90.0, 1);

  l_side_wall = read_nurbs("plane.db");
  set_attribute(l_side_wall, white);
  set_scale(l_side_wall, 2.0, 1.5, 2.0);
  set_translate(l_side_wall, 0, 14, 8);
  set_x_rotate(l_side_wall, 90.0, 1);
  set_z_rotate(l_side_wall, 90.0, 1);
  set_translate(l_side_wall, 10, 7, 0);

  r_side_wall = read_nurbs("plane.db");
  set_attribute(r_side_wall, white);
  set_scale(r_side_wall, 2.0, 1.5, 2.0);
  set_translate(r_side_wall, 0, 14, 8);
  set_x_rotate(r_side_wall, 90.0, 1);
  set_z_rotate(r_side_wall, -90.0, 1);
  set_translate(r_side_wall, -10, 7, 0);

  set1 = create_list(guitar1, "set1");
  set1 = insert_in_list(set1, stand1);

  set2 = create_list(guitar2, "set2");
  set2 = insert_in_list(set2, stand2);
  set_translate(set2, 4.0, 3.0, 0.0);

  set3 = create_list(guitar3, "set3");
  set3 = insert_in_list(set3, stand3);
  set_translate(set3, -4.0, 3.0, 0.0);

  scene = create_list(ground, "scene");
  scene = insert_in_list(scene, back_wall);
  scene = insert_in_list(scene, l_side_wall);
  scene = insert_in_list(scene, r_side_wall);
  scene = insert_in_list(scene, set1);
  scene = insert_in_list(scene, set2);
  scene = insert_in_list(scene, set3);

  save_scene("gibson.md", "scene_guitar", scene);
  return(0);
}
